#include <stdio.h>
#include <stdlib.h>
#include <math.h>
double ** vyroba2Dpole(int r, int s)
{
    double **pA;
    int i;
    pA=(double **)malloc(r*sizeof(double *));
    for(i=0; i<r; i++)
        pA[i]=(double *)malloc(s*sizeof(double));
    return(pA);
}
void uvolni(double **pA, int r)
{
    int i;
    for(i=0; i<r; i++)
        free((void *)pA[i]);
    free((void *)pA);
}
void doSouboru(double **pA, int r, int s, int k)
{
    FILE *fw,*fr;
    char jmeno[30], vystup[34], radka[50];
    int i,j,q;
    printf("Zadej jmeno souboru bez pripony: ");
    scanf("%29s",jmeno);
    sprintf(vystup,"%s.csv",jmeno);
    printf("\nUklada se do souboru %s\n",vystup);
    if((fw=fopen(vystup,"w"))==NULL)
    {
        printf("Soubor %s nelze otevrit",vystup);
        exit(-1);
    }
    q=0;
    for(i=0; i<=360; i+=k)
    {
        pA[q][0]=(double)i;
        pA[q][1]=sin(pA[q][0]*M_PI/180); //prevod na radiany
        if(i==0)
            sprintf(radka,"%5.0f;%10.4f;%c;\n",pA[q][0],pA[q][1],'-');
        else
        {
            pA[q][2]=log(pA[q][0]);
            sprintf(radka,"%5.0f;%10.4f;%10.4f;\n",pA[q][0],pA[q][1],pA[q][2]);
        }
        printf("%s",radka);
        j=0;
        while(radka[j]!='\0')
        {
            if(radka[j]=='.')
                radka[j]=',';
            j++;
        }
        fprintf(fw,"%s",radka);
        q++;
    }
    if((fclose(fw))==EOF)
    {
        printf("Soubor %s nelze uzavrit",vystup);
        exit(-1);
    }
    if((fr=fopen(vystup,"r"))==NULL)
    {
        printf("Soubor %s nelze otevrit",vystup);
        exit(-1);
    }
    if((fw=fopen("kopie.txt","w"))==NULL)
    {
        printf("Soubor %s nelze otevrit",vystup);
        exit(-1);
    }
    char c;
    while((c=getc(fr))!=EOF)
    {
        putc(c,fw); // znak do souboru
        putchar(c); // znak na obrazovku
    }
    if((fclose(fw))==EOF)
    {
        printf("Soubor %s nelze uzavrit",vystup);
        exit(-1);
    }
    if((fclose(fr))==EOF)
    {
        printf("Soubor %s nelze uzavrit",vystup);
        exit(-1);
    }
}
int main()
{
    int k,r,s;
    double **pA;
    printf("Zadej krok!\n");
    scanf("%d",&k);
    r=360/k+1;
    s=3;
    pA=vyroba2Dpole(r,s);
    doSouboru(pA,r,s,k);
    uvolni(pA,r);
    return 0;
}
